package $package;

import javax.jws.WebService;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.ow2.weblab.core.model.Resource;
import org.ow2.weblab.core.services.AccessDeniedException;
import org.ow2.weblab.core.services.Analyser;
import org.ow2.weblab.core.services.ContentNotAvailableException;
import org.ow2.weblab.core.services.InsufficientResourcesException;
import org.ow2.weblab.core.services.InvalidParameterException;
import org.ow2.weblab.core.services.ServiceNotConfiguredException;
import org.ow2.weblab.core.services.UnexpectedException;
import org.ow2.weblab.core.services.UnsupportedRequestException;
import org.ow2.weblab.core.services.analyser.ProcessArgs;
import org.ow2.weblab.core.services.analyser.ProcessReturn;

/**
 * Template for WebLab service which uses Analyser interface
 * 
 * @author WebLab Team
 */
@WebService(endpointInterface = "org.ow2.weblab.core.services.Analyser")
public class $className implements Analyser {


	/**
	 * The instance of logger used inside $className
	 */
	private final Log logger;


	/**
	 * Constructor
	 */
	public $className() {
		this.logger = LogFactory.getLog(this.getClass());

		// TODO Initialise other fields if needed

		this.logger.info("Service $className successfully started");
	}


	@Override
	public ProcessReturn process(final ProcessArgs args) throws AccessDeniedException, ContentNotAvailableException, InsufficientResourcesException,
			InvalidParameterException, ServiceNotConfiguredException, UnexpectedException, UnsupportedRequestException {
		this.logger.debug("Early start of process method.");

		final Resource resource = this.checkProcessArgs(args);

		this.logger.info("Start processing resource " + resource.getUri() + ".");

		// TODO Implement your method here!

		this.logger.error("Method process not yet implemented.");
		throw new UnsupportedRequestException("Method process not yet implemented.");
	}


	/**
	 * Method that tests that the ProcessArgs is correct regarding specification of $className
	 * 
	 * @param args
	 *            The argument received by the process method
	 * @return The resource inside <code>args</code>
	 * @throws InvalidParameterException
	 *             If args or the resource it contains is <code>null</code>
	 */
	protected Resource checkProcessArgs(final ProcessArgs args) throws InvalidParameterException {
		if (args == null) {
			throw new InvalidParameterException("ProcessArgs is null.");
		}
		final Resource resource = args.getResource();
		if (resource == null) {
			throw new InvalidParameterException("Resource in ProcessArgs is null.");
		}

		// TODO Maybe implement a better test for your resource (for instance, is a Document required?)
		// TODO Test the existence of an usageContext if required

		return resource;
	}

}
